
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[]="@(#)83	1.63  src/oss/kazn/kail/kail_syscall.c, oss.kazn.src, oss600, 101018a  10/15/10  20:27:30";
#include <linux/version.h>






#include <linux/module.h>

#include <linux/kernel.h>


#include <linux/types.h>

#include <linux/slab.h>

#include <linux/vmalloc.h>

#include <linux/smp_lock.h>

#include <linux/sched.h>

#include <linux/file.h>

#include <linux/fs.h>

#include <net/sock.h>

#include <asm/atomic.h>

#include <asm/semaphore.h>

#include <asm/current.h>

#include <asm/uaccess.h>

#include <asm/unistd.h>


#include <linux/nfs_fs.h>
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;





extern volatile struct timespec *kail_xtime;
extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long kail_copy_to_user(void *, const void *, unsigned long);
extern unsigned long kail_copy_from_user(void *, const void *, unsigned long);

extern void kail_kernel_free(void *,unsigned long);
extern void * kail_kernel_malloc(unsigned long);





extern asmlinkage void kail_mutex_init(void **);





extern void kail_mutex_lock(void **);
extern int kail_mutex_trylock(void **);
extern void kail_mutex_unlock(void **);


extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);





extern void kail_wake_up(void **);
extern void kail_cond_wait(void **, void **);
extern int kail_cond_wait_intr(void **, void **);

extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void kail_iclock_lock(void **);
extern void kail_iclock_unlock(void **);
extern int kail_iclock_trylock(void **);
extern void kail_iclock_cond_wait(void **,void **);

extern void kail_iclock_unlock2(void **, void **);

extern asmlinkage void kail_iclock_destroy(void **);






extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);



extern asmlinkage int kail_tid_to_pid(int);
extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));


extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);



extern int kail_current_files_close_on_exec(int);


extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);
extern int kail_fd_to_dev(int, dev_t *);
extern int kail_fd_to_name(int, char **, int *);
extern int kail_fd_to_socket(int,void **);

extern int kail_socket_shutdown(void *);
extern int kail_check_pid(int);
extern int kail_get_pid_pgrp(int,int *);
extern int kail_get_pid_uid(int,int *,int *);
extern void kail_scan_procs(void *);


extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);



extern void kail_atomic_add(int,void *);


extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );

extern asmlinkage int kail_copy_exec_argv(void *, char *, int);


struct group_info;





extern gid_t * kail_groups_blocks(struct group_info *,int);
extern int kail_groups_ngroups(struct group_info *);
extern int kail_groups_nblocks(struct group_info *);
struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;



        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);



extern int kail_minor(void *);


extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);





extern asmlinkage void * kail_unixDescToVnode(int);
extern asmlinkage void kail_releVnode(void *);
extern asmlinkage void kail_holdVnode(void *);


extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;





        sys_call_fn call32_pre;
        sys_call_fn call32_post;

};

extern int struct_cppath_size;

struct kail_lsmhooks {
        int lsmhook_index;
        sys_call_fn lsmhook_pre;
        sys_call_fn lsmhook_post;
};
extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *,struct kail_lsmhooks *);



extern asmlinkage void kail_restore_syscalls(void);

extern int change_KailPerm2ro(void);

extern int change_KailPerm2rw(int cred);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#if defined(LINUX_RHEL4) || defined(LINUX_SLES10) || defined(LINUX_RHEL5)
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
struct syscall_glue_table {
        long kail_syscall_index;
        long syscall_index;
        sys_call_fn syscall_glue_pre;
        sys_call_fn syscall_glue_post;
        sys_call_fn syscall_glue_pre_post;

        long syscall_index32;
        sys_call_fn sys32call_glue_pre;
        sys_call_fn sys32call_glue_post;
        sys_call_fn sys32call_glue_pre_post;

};
extern struct syscall_glue_table kail_syscall_glue_list_x[];
extern struct syscall_glue_table * kail_syscall_glue_list;


struct syscall_table {
        sys_call_fn orig_syscall;
        sys_call_fn syscall_pre;
        sys_call_fn syscall_post;

        sys_call_fn orig_sys32call;
        sys_call_fn syscall32_pre;
        sys_call_fn syscall32_post;


};
extern struct syscall_table kail_syscall_list[];
typedef unsigned int uid32_t;
typedef unsigned int gid32_t;
struct kail_lsmhooks_table {
        sys_call_fn lsmhooks_pre;
        sys_call_fn lsmhooks_post;
};
extern struct kail_lsmhooks_table kail_lsmhooks_list[];
unsigned int kailHookEntryCount = 0;
unsigned int kail32HookEntryCount = 0;
unsigned int kailHookEntryFailCount = 0;
extern asmlinkage long kail_kill_glue_pre (pid_t,int); extern asmlinkage long kail_kill_glue_post (pid_t,int); extern asmlinkage long kail_kill_glue_pre_post (pid_t,int);
extern asmlinkage long kail_tkill_glue_pre (pid_t,int); extern asmlinkage long kail_tkill_glue_post (pid_t,int); extern asmlinkage long kail_tkill_glue_pre_post (pid_t,int);
extern asmlinkage long kail_tgkill_glue_pre (pid_t,pid_t,int); extern asmlinkage long kail_tgkill_glue_post (pid_t,pid_t,int); extern asmlinkage long kail_tgkill_glue_pre_post (pid_t,pid_t,int);
extern asmlinkage long kail_umount_glue_pre (char *); extern asmlinkage long kail_umount_glue_post (char *); extern asmlinkage long kail_umount_glue_pre_post (char *);
extern asmlinkage long kail_umount2_glue_pre (char *,int); extern asmlinkage long kail_umount2_glue_post (char *,int); extern asmlinkage long kail_umount2_glue_pre_post (char *,int);
extern asmlinkage long kail_mount_glue_pre (char *,char *,char *,unsigned long,void *); extern asmlinkage long kail_mount_glue_post (char *,char *,char *,unsigned long,void *); extern asmlinkage long kail_mount_glue_pre_post (char *,char *,char *,unsigned long,void *);
 extern asmlinkage long kail_kill_glue32_pre (pid_t,int); extern asmlinkage long kail_kill_glue32_post (pid_t,int); extern asmlinkage long kail_kill_glue32_pre_post (pid_t,int);
 extern asmlinkage long kail_tkill_glue32_pre (pid_t,int); extern asmlinkage long kail_tkill_glue32_post (pid_t,int); extern asmlinkage long kail_tkill_glue32_pre_post (pid_t,int);
 extern asmlinkage long kail_tgkill_glue32_pre (pid_t,pid_t,int); extern asmlinkage long kail_tgkill_glue32_post (pid_t,pid_t,int); extern asmlinkage long kail_tgkill_glue32_pre_post (pid_t,pid_t,int);
 extern asmlinkage long kail_mount_glue32_pre (char *,char *,char *,unsigned long,void *); extern asmlinkage long kail_mount_glue32_post (char *,char *,char *,unsigned long,void *); extern asmlinkage long kail_mount_glue32_pre_post (char *,char *,char *,unsigned long,void *);
 extern asmlinkage long kail_umount_glue32_pre (char *); extern asmlinkage long kail_umount_glue32_post (char *); extern asmlinkage long kail_umount_glue32_pre_post (char *);
 extern asmlinkage long kail_umount2_glue32_pre (char *,int); extern asmlinkage long kail_umount2_glue32_post (char *,int); extern asmlinkage long kail_umount2_glue32_pre_post (char *,int);
struct syscall_glue_table * trampoline_glue_list = (struct syscall_glue_table *)0;
struct syscall_glue_table * kail_syscall_glue_list;
struct syscall_glue_table kail_syscall_glue_list_x[20] = {
    { 0, __NR_kill, (sys_call_fn)kail_kill_glue_pre, (sys_call_fn)kail_kill_glue_post, (sys_call_fn)kail_kill_glue_pre_post, __NR_kill, (sys_call_fn)kail_kill_glue32_pre, (sys_call_fn)kail_kill_glue32_post, (sys_call_fn)kail_kill_glue32_pre_post },
    { 1, __NR_tkill, (sys_call_fn)kail_tkill_glue_pre, (sys_call_fn)kail_tkill_glue_post, (sys_call_fn)kail_tkill_glue_pre_post, __NR_tkill, (sys_call_fn)kail_tkill_glue32_pre, (sys_call_fn)kail_tkill_glue32_post, (sys_call_fn)kail_tkill_glue32_pre_post },
    { 2, __NR_tgkill, (sys_call_fn)kail_tgkill_glue_pre, (sys_call_fn)kail_tgkill_glue_post, (sys_call_fn)kail_tgkill_glue_pre_post, __NR_tgkill, (sys_call_fn)kail_tgkill_glue32_pre, (sys_call_fn)kail_tgkill_glue32_post, (sys_call_fn)kail_tgkill_glue32_pre_post },
    { 3, __NR_umount, (sys_call_fn)kail_umount_glue_pre, (sys_call_fn)kail_umount_glue_post, (sys_call_fn)kail_umount_glue_pre_post, __NR_umount, (sys_call_fn)kail_umount_glue32_pre, (sys_call_fn)kail_umount_glue32_post, (sys_call_fn)kail_umount_glue32_pre_post },
    { 4, __NR_umount2, (sys_call_fn)kail_umount2_glue_pre, (sys_call_fn)kail_umount2_glue_post, (sys_call_fn)kail_umount2_glue_pre_post, __NR_umount2, (sys_call_fn)kail_umount2_glue32_pre, (sys_call_fn)kail_umount2_glue32_post, (sys_call_fn)kail_umount2_glue32_pre_post },
    { 5, __NR_mount, (sys_call_fn)kail_mount_glue_pre, (sys_call_fn)kail_mount_glue_post, (sys_call_fn)kail_mount_glue_pre_post, __NR_mount, (sys_call_fn)kail_mount_glue32_pre, (sys_call_fn)kail_mount_glue32_post, (sys_call_fn)kail_mount_glue32_pre_post },
    { -1, -1, (sys_call_fn)NULL, (sys_call_fn)NULL, (sys_call_fn)NULL, 0, (sys_call_fn)NULL, (sys_call_fn)NULL, (sys_call_fn)NULL }
};
  extern asmlinkage long trampoline(void);
  extern asmlinkage long trampolineAddr;


  unsigned long trampoline_dummy (void) {
    return -1;
  }
asm(
"    .globl trampoline,trampolineAddr \n\t"
"trampoline:\n\t"
"       basr %r1,0\n\t"
".TL0:   lg   %r1,.TL1-.TL0(%r1)\n\t"
"       br   %r1\n\t"
"trampolineAddr:\n\t"
".TL1:   .quad trampoline_dummy\n\t"
);
sys_call_fn kail_sys_clone = NULL;
sys_call_fn kail_sys_fork = NULL;
sys_call_fn kail_sys_vfork = NULL;
sys_call_fn kail_sys_clone32 = NULL;
sys_call_fn kail_sys_fork32 = NULL;
sys_call_fn kail_sys_vfork32 = NULL;
sys_call_fn kail_sys_execve = NULL;
sys_call_fn *kail_sys_execveSCT = NULL;
static void * getVMaddr(void *);
struct syscall_table kail_syscall_list[256] = {{NULL,NULL,NULL}};


 extern long *kail_sys_call_table;


  extern long *kail_sys_call_table32;
#include <linux/security.h>
    extern struct security_operations kail_sec_ops;
struct kail_lsmhooks_table kail_lsmhooks_list[30];
long lsmMemClobberCheck[1];
int kail_sec_ops_loaded = 0;







extern void kail_glue_first(void);
extern void kail_glue_last(void);
extern void kail_glue_firstS(void);
extern void kail_glue_lastS(void);
asmlinkage int

kail_trap_syscalls(struct kail_syscall_prepost *syscall_prepost,struct kail_lsmhooks *lsmhooks)



{
    struct kail_syscall_prepost * prepost_table;

    struct kail_lsmhooks * lsmhooks_table;





    unsigned int syscallHookEntryCount = 0;
    unsigned int prepostTableIndex = 0;
    int ignoreCurSyscall = 0;
    int loopCount;

    unsigned int lsmhookEntryCount = 0;






    unsigned long sys_callDummy = 0L;
    ;
    ;
    ;
    ;
    ;
    kail_syscall_glue_list = &kail_syscall_glue_list_x[0];
    if (((__u64)(&kail_glue_first) > 0x7FFFFFFF) ||
        ((__u64)(&kail_glue_last) > 0x7FFFFFFF) ||
        ((__u64)(&kail_glue_firstS) > 0x7FFFFFFF) ||
        ((__u64)(&kail_glue_lastS) > 0x7FFFFFFF)) {
       uint32_t *testSyscallEntry = ((uint32_t *)&(((uint32_t *)kail_sys_call_table)[__NR_umount]));
       printk("INFO: kail_syscall TAMOS driver code is beyond the first 2GBs %lX (%lX)\n",
             (unsigned long)&kail_glue_first,(unsigned long)*testSyscallEntry);





       if (kail_setup_trampoline_syscalls(syscall_prepost)) {
           printk("ERROR: TAMOS: kail_syscall.c: preparing beyond 2GB FAILED \n");
          return -2;
       } else {
          printk("TAMOS INFO: setup beyond 2GB: SUCCEEDED \n");
       }

    }


    int indexError = 0;
    ;
    ;

    ;




    ;
    if (kail_sys_call_table == 0L) {
       printk("WARNING: !!!! kail_syscall.c kail_sys_call_table is NULL\n");
       return 2;
    }

    if (((uint32_t *)kail_sys_call_table) == 0L) {
       printk("WARNING: !!!! kail_syscall.c table is NULL\n");
         return 2;
    }
    memset(kail_syscall_list, -1, sizeof(kail_syscall_list));
    for (prepost_table = syscall_prepost;prepost_table->call_index != -1;prepost_table++) {
            const uint32_t kail_index = prepost_table->call_index;
            struct syscall_table *sct;
            struct syscall_glue_table *sc_glue_t;
            uint32_t syscall_index;
            int placeHolderOnly ;
            int syscall32BitOnly ;





            if (kail_index == -2) {

               continue;
            }
            sct = &(kail_syscall_list[kail_index]);



            sc_glue_t = kail_syscall_glue_list + kail_index;

            syscall_index = sc_glue_t->syscall_index;

            ++prepostTableIndex;
            placeHolderOnly = 0;
            syscall32BitOnly = 0;




            ignoreCurSyscall = 0;

            if (syscall_index == -1) {
                placeHolderOnly = 1;






            } else
            if (syscall_index == -32) {
                syscall32BitOnly = 1;
                syscall_index = 0;

                ;



            }
           if (kail_index >= 20) {
              printk("TAMOS WARNING: ignoring glue call entry: prePost index:%d kailIndex: %d max: %d \n",
                                     prepostTableIndex, kail_index, 20);
              continue;
           }
           if (kail_index != sc_glue_t->kail_syscall_index) {
              printk("TAMOS ERROR: prepost table entry: %d  KAIL_xx:%d != Glue KAIL_xx: %d: scall: %d\n",
                     prepostTableIndex, kail_index, sc_glue_t->kail_syscall_index, syscall_index);
              continue;
           }
           if ((! syscall32BitOnly)
               && (! (sc_glue_t->syscall_glue_pre))
               && (! (sc_glue_t->syscall_glue_post))
               && (! (sc_glue_t->syscall_glue_pre_post)) ) {
              printk("TAMOS INFO: ignoring. No Pre or post glue functions: prePost: %d glue: %d scall: %d\n",
                       prepostTableIndex, kail_index, syscall_index);
              continue;
           } else

           if ((syscall32BitOnly)
               && (! (sc_glue_t->sys32call_glue_pre))
               && (! (sc_glue_t->sys32call_glue_post))
               && (! (sc_glue_t->sys32call_glue_pre_post)) ) {
              printk("TAMOS INFO: ignoring. 32bitOnly No Pre or post glue functions: prePost: %d glue: %d scall: %d\n",
                       prepostTableIndex, kail_index, syscall_index);
              continue;

           }
            uint32_t *sys_call = ((uint32_t *)&(((uint32_t *)kail_sys_call_table)[syscall_index]));
            const uint32_t syscall_index32 = sc_glue_t->syscall_index;


            uint32_t *sys_call32 = ((uint32_t *)&(((uint32_t *)kail_sys_call_table32)[syscall_index32]));
            ;
            ++syscallHookEntryCount;
            ;




                if ((unsigned long)sct->orig_syscall != (unsigned long)-1) {
                ;

                }
            memset(sct,0,sizeof(*sct));


           if ((! placeHolderOnly) && (! syscall32BitOnly) &&
                ((unsigned long)syscall_index > (unsigned long) __NR_syscall_max)) {

              printk("TAMOS INFO: ignoring NR call index: %d  at kail index: %d\n", syscall_index, kail_index);
              continue;
           }
           if (placeHolderOnly || syscall32BitOnly) {
                 sys_call = &sys_callDummy;

                 sys_call32 = &sys_callDummy;

           }
           if ((kail_index != -1)
                && (! syscall32BitOnly)
                )
           {
            ;
             if ((sc_glue_t->syscall_glue_pre) || (sc_glue_t->syscall_glue_pre_post)) {





                ;



                ;

                ;
                ;




                sct->orig_syscall = (sys_call_fn)(*sys_call);
                switch(syscall_index) {
                case __NR_execve:
                      kail_sys_execve = sct->orig_syscall;




                      break;

                case __NR_clone:


                      kail_sys_clone = sct->orig_syscall;
                      break;
                case __NR_fork:
                      kail_sys_fork = sct->orig_syscall;




                      break;
                case __NR_vfork:
                      kail_sys_vfork = sct->orig_syscall;




                      break;
                }
                ;
                if (prepost_table->call_pre) {
                        if (prepost_table->call_post) {
                                ;




                                do { if ((sys_call) && ((unsigned long)((sc_glue_t->syscall_glue_pre_post)))) { ++kailHookEntryCount; if (! ignoreCurSyscall) { *(sys_call) = (unsigned long)((sc_glue_t->syscall_glue_pre_post)); } else { printk("%d: index: %d kailStoreSyscallAddr  WARNING IGNORING syscall  *(%lX) = %lX \n", 2, syscall_index,(unsigned long)sys_call, (unsigned long)(unsigned long)((sc_glue_t->syscall_glue_pre_post))); } } else { ++kailHookEntryFailCount; printk("%d: index: %d kailStoreSyscallAddr  WARNING NULL VALUE  *(%lX) = %lX \n", 2, syscall_index,(unsigned long)sys_call, (unsigned long)(unsigned long)((sc_glue_t->syscall_glue_pre_post))); } } while ( 0);


                        } else {
                                ;




                                do { if ((sys_call) && ((unsigned long)((sc_glue_t->syscall_glue_pre)))) { ++kailHookEntryCount; if (! ignoreCurSyscall) { *(sys_call) = (unsigned long)((sc_glue_t->syscall_glue_pre)); } else { printk("%d: index: %d kailStoreSyscallAddr  WARNING IGNORING syscall  *(%lX) = %lX \n", 3, syscall_index,(unsigned long)sys_call, (unsigned long)(unsigned long)((sc_glue_t->syscall_glue_pre))); } } else { ++kailHookEntryFailCount; printk("%d: index: %d kailStoreSyscallAddr  WARNING NULL VALUE  *(%lX) = %lX \n", 3, syscall_index,(unsigned long)sys_call, (unsigned long)(unsigned long)((sc_glue_t->syscall_glue_pre))); } } while ( 0);



                        }
                } else
                if (prepost_table->call_post) {
                                ;




                                do { if ((sys_call) && ((unsigned long)((sc_glue_t->syscall_glue_post)))) { ++kailHookEntryCount; if (! ignoreCurSyscall) { *(sys_call) = (unsigned long)((sc_glue_t->syscall_glue_post)); } else { printk("%d: index: %d kailStoreSyscallAddr  WARNING IGNORING syscall  *(%lX) = %lX \n", 4, syscall_index,(unsigned long)sys_call, (unsigned long)(unsigned long)((sc_glue_t->syscall_glue_post))); } } else { ++kailHookEntryFailCount; printk("%d: index: %d kailStoreSyscallAddr  WARNING NULL VALUE  *(%lX) = %lX \n", 4, syscall_index,(unsigned long)sys_call, (unsigned long)(unsigned long)((sc_glue_t->syscall_glue_post))); } } while ( 0);


                } else
                if ((sc_glue_t->syscall_glue_pre_post)) {
                       ;




                       do { if ((sys_call) && ((unsigned long)((sc_glue_t->syscall_glue_pre_post)))) { ++kailHookEntryCount; if (! ignoreCurSyscall) { *(sys_call) = (unsigned long)((sc_glue_t->syscall_glue_pre_post)); } else { printk("%d: index: %d kailStoreSyscallAddr  WARNING IGNORING syscall  *(%lX) = %lX \n", 5, syscall_index,(unsigned long)sys_call, (unsigned long)(unsigned long)((sc_glue_t->syscall_glue_pre_post))); } } else { ++kailHookEntryFailCount; printk("%d: index: %d kailStoreSyscallAddr  WARNING NULL VALUE  *(%lX) = %lX \n", 5, syscall_index,(unsigned long)sys_call, (unsigned long)(unsigned long)((sc_glue_t->syscall_glue_pre_post))); } } while ( 0);


                } else {
                     ;


                }





               ;
               ;

             }
              else {
                printk(" TAMOS WARNING: IGNORING: no GLUE_PRE %d index: %d syscall: %d postAddr: %p\n",
                                prepostTableIndex, kail_index, syscall_index,
                                (sc_glue_t->syscall_glue_post));
             }
          } else {




              ;
          }
            if ((sc_glue_t->sys32call_glue_pre)) {
                ;



                ;

                ;
                ;







                   sct->orig_sys32call = (sys_call32) ? (sys_call_fn)(*sys_call32) : (sys_call_fn)0;
                   if (prepost_table->call_pre) {
                        if (prepost_table->call_post) {
                                ;




                                do { if ((sys_call32) && ((unsigned long)((sc_glue_t->sys32call_glue_pre_post)))) { ++kailHookEntryCount; if (! ignoreCurSyscall) { *(sys_call32) = (unsigned long)((sc_glue_t->sys32call_glue_pre_post)); } else { printk("%d: index: %d kailStoreSyscallAddr  WARNING IGNORING syscall  *(%lX) = %lX \n", 321, syscall_index32,(unsigned long)sys_call32, (unsigned long)(unsigned long)((sc_glue_t->sys32call_glue_pre_post))); } } else { ++kailHookEntryFailCount; printk("%d: index: %d kailStoreSyscallAddr  WARNING NULL VALUE  *(%lX) = %lX \n", 321, syscall_index32,(unsigned long)sys_call32, (unsigned long)(unsigned long)((sc_glue_t->sys32call_glue_pre_post))); } } while ( 0);


                        } else {
                                ;




                                do { if ((sys_call32) && ((unsigned long)((sc_glue_t->sys32call_glue_pre)))) { ++kailHookEntryCount; if (! ignoreCurSyscall) { *(sys_call32) = (unsigned long)((sc_glue_t->sys32call_glue_pre)); } else { printk("%d: index: %d kailStoreSyscallAddr  WARNING IGNORING syscall  *(%lX) = %lX \n", 322, syscall_index32,(unsigned long)sys_call32, (unsigned long)(unsigned long)((sc_glue_t->sys32call_glue_pre))); } } else { ++kailHookEntryFailCount; printk("%d: index: %d kailStoreSyscallAddr  WARNING NULL VALUE  *(%lX) = %lX \n", 322, syscall_index32,(unsigned long)sys_call32, (unsigned long)(unsigned long)((sc_glue_t->sys32call_glue_pre))); } } while ( 0);



                        }
                   } else {
                        if (prepost_table->call_post) {
                                ;




                                do { if ((sys_call32) && ((unsigned long)((sc_glue_t->sys32call_glue_post)))) { ++kailHookEntryCount; if (! ignoreCurSyscall) { *(sys_call32) = (unsigned long)((sc_glue_t->sys32call_glue_post)); } else { printk("%d: index: %d kailStoreSyscallAddr  WARNING IGNORING syscall  *(%lX) = %lX \n", 323, syscall_index,(unsigned long)sys_call32, (unsigned long)(unsigned long)((sc_glue_t->sys32call_glue_post))); } } else { ++kailHookEntryFailCount; printk("%d: index: %d kailStoreSyscallAddr  WARNING NULL VALUE  *(%lX) = %lX \n", 323, syscall_index,(unsigned long)sys_call32, (unsigned long)(unsigned long)((sc_glue_t->sys32call_glue_post))); } } while ( 0);



                        } else {
                                ;

                        }
                   }


               ;
               ;

            }
            else {
               printk("TAMOS INFO: kail_syscall.c  IGNORING GLUE_ADDERSS32_PRE scall: %d scall32: %d POST? %lX\n",
                               syscall_index, syscall_index32, (unsigned long)((sc_glue_t->sys32call_glue_post)) );
            }







              ;


            sct->syscall_pre = prepost_table->call_pre;
            sct->syscall_post = prepost_table->call_post;
               ;


    }
    if (indexError != 0) {
       printk("TAMOS ERROR: (%ld) prepost table indexes TOO BIG \n", indexError);
       return 1;
    }







   ;


   printk("TAMOS INFO: setting up as a security module\n");

    for (lsmhooks_table = lsmhooks;lsmhooks_table->lsmhook_index != -1;lsmhooks_table++) {
        lsmhookEntryCount++;
            const uint32_t index = lsmhooks_table->lsmhook_index;
            struct kail_lsmhooks_table *lsmh = &(kail_lsmhooks_list[index]);
            if (index >= 30) {
               printk("ERROR lsmhook_index of (%ld) is BIGGER than(%ld)\n", (long)index, (long)30);
               return -1;
            }

            if ((unsigned long)&lsmh->lsmhooks_pre >= (unsigned long)&lsmMemClobberCheck[0]) {
               printk(" ERROR lsmhook_index of (%ld) max: %ld is clobbering lsmMemClobberCheck: %lX\n",
                            (long)index, (long)30, (unsigned long)&lsmMemClobberCheck[0]);
               return -1;
            }


;
;


            lsmh->lsmhooks_pre = lsmhooks_table->lsmhook_pre;
            lsmh->lsmhooks_post = lsmhooks_table->lsmhook_post;
;
;

    }

    ;



    if (current->security != NULL) {
        printk("selinux detected (current->security=%#X) -- aborting.\n",
                        current->security);
        return -1;
    }

    if (register_security(&kail_sec_ops)) {





        ;
        ;





        if (unregister_security(security_ops)) {
           printk("TAMOS INFO: unregister didnt work... return=1\n");
           ;

           return 1;
        } else {
           ;



           if (register_security(&kail_sec_ops)) {
                printk("--> ERROR! 2nd register_security didn't work; aborting\n");
                ;

                return 1;
           }
        }


    }




    kail_sec_ops_loaded = 1;





    printk("TAMOS INFO: kaznmod successfully inserted (%d:(%d:%d) of %d) as a security framework and overlaying.\n",
                 lsmhookEntryCount, kailHookEntryCount, kailHookEntryFailCount, syscallHookEntryCount);




    ;
   printk("TAMOS INFO: Initialization complete\n");
    return 0;
}
EXPORT_SYMBOL(kail_trap_syscalls);







asmlinkage void
kail_restore_syscalls(void)
{

    struct syscall_table *sct;
    struct syscall_glue_table *sc_glue_t;
 int ignoreCurSyscall = 0;
 printk("restoring kail syscall\n");
 return;
    for (sct = kail_syscall_list,sc_glue_t = kail_syscall_glue_list;
          sc_glue_t->syscall_index != -1;
           sct++,sc_glue_t++) {
            const uint32_t syscall_index = sc_glue_t->syscall_index;
            uint32_t *sys_call = ((uint32_t *)&(((uint32_t *)kail_sys_call_table)[syscall_index]));
            const uint32_t syscall_index32 = sc_glue_t->syscall_index;


            uint32_t *sys_call32 = ((uint32_t *)&(((uint32_t *)kail_sys_call_table32)[syscall_index32]));
            ;






;
;
            if (sct->orig_syscall)




                    do { if ((sys_call) && ((unsigned long)(sct->orig_syscall))) { ++kailHookEntryCount; if (! ignoreCurSyscall) { *(sys_call) = (unsigned long)(sct->orig_syscall); } else { printk("%d: index: %d kailStoreSyscallAddr  WARNING IGNORING syscall  *(%lX) = %lX \n", 5, syscall_index,(unsigned long)sys_call, (unsigned long)(unsigned long)(sct->orig_syscall)); } } else { ++kailHookEntryFailCount; printk("%d: index: %d kailStoreSyscallAddr  WARNING NULL VALUE  *(%lX) = %lX \n", 5, syscall_index,(unsigned long)sys_call, (unsigned long)(unsigned long)(sct->orig_syscall)); } } while ( 0);



;



;
;
            if (sct->orig_sys32call)

                    *sys_call32 = (long)(sct->orig_sys32call);
;


    }
    if (security_ops == &kail_sec_ops) {
        ;



        if (unregister_security(&kail_sec_ops)) {
                printk("--> ERROR! unregister_security didn't work \n");
                return;
        }
        ;

    } else {
        ;

    }



}
EXPORT_SYMBOL(kail_restore_syscalls);
asmlinkage int
kail_setup_trampoline_syscalls(struct kail_syscall_prepost *syscall_prepost)

{
   int trampolineSize;
   char * curTrampolineFnPtr;
   unsigned long *curBranchAddr;
   int trampolineLOCindex;
   struct kail_syscall_prepost * prepost_table;
   unsigned char *tmpPtr;
   unsigned short *tmpShrtPtr;
   unsigned long *tmpLongPtr;
   int glueListSize;
   int glueListBfrSize;
   int glueListFnCount = 0;
   char *trampolineBfr = 0;
   int trampolineBfrSize = 0;
   int trampolineBfrEntrySize;
   char * curGlueTypeMsg;






   trampolineLOCindex = ((unsigned long)&trampolineAddr - (unsigned long)trampoline);

   trampolineSize = trampolineLOCindex + 8;
   trampolineBfrEntrySize = trampolineSize + 2;

    ;



    tmpPtr = (char *)trampoline;
    ;







   glueListSize = kail_setup_for_trampoline(&kail_syscall_glue_list_x[0],&glueListFnCount, 1);

   if (glueListFnCount) {
      trampolineBfrSize = (trampolineBfrEntrySize + 4) * glueListFnCount;
      trampolineBfr = kmalloc(trampolineBfrSize + 32, GFP_DMA);

   }
   if (! trampolineBfr) {
      printk("ack! trampoline bfr kmalloc DMA (%d) failed!\n",trampolineBfrSize );
      return 1;
   }



   printk("TAMOS INFO: Beyond 2GB ID: %lX-%lX-%lX\n", (unsigned long)trampolineBfr,
               (char *)trampolineBfr + 32,
                (char *)trampolineBfr + 32 + trampolineBfrSize);
   memcpy((char *)trampolineBfr, "TRAMPOLINEbfr", 13);
   trampolineBfr += 32;

   if (glueListSize > 0) {




      glueListBfrSize = (glueListSize + 1) * sizeof(struct syscall_glue_table);
      trampoline_glue_list = kmalloc(glueListBfrSize + 32, GFP_KERNEL);
   }

   if (trampoline_glue_list == NULL) {
      printk("ack! trampoline gluelist kmalloc KERNEL (%d) failed!\n",glueListBfrSize);
      return 1;
   }



   printk("TAMOS INFO: beyond 2GB ID2: %lX-%lX-%lX\n", (unsigned long)trampoline_glue_list,
             (char *)trampoline_glue_list + 32,
             (char *)trampoline_glue_list + 32 + glueListBfrSize);
   memcpy((char *)trampoline_glue_list, "TRAMPOLINEglueList", 19);
   (char *)trampoline_glue_list += 32;



   memcpy((char *)trampoline_glue_list, kail_syscall_glue_list, glueListBfrSize);


   (trampoline_glue_list + glueListSize)->syscall_index = -1;
   (trampoline_glue_list + glueListSize)->kail_syscall_index = -1;

   ;



    ;
    curTrampolineFnPtr = trampolineBfr;
    for (prepost_table = syscall_prepost;prepost_table->call_index != -1;prepost_table++) {
            const uint32_t index = prepost_table->call_index;
            int keepLooping;
            sys_call_fn curGlueFunction;
            sys_call_fn *curTrampolineGlueFnEntry;





            struct syscall_glue_table *sc_glue_t = kail_syscall_glue_list + index;
            struct syscall_glue_table *trampoline_glue_t = trampoline_glue_list + index;

            memset(trampoline_glue_t, 0, sizeof(*trampoline_glue_t));
            trampoline_glue_t->syscall_index = sc_glue_t->syscall_index;

            trampoline_glue_t->kail_syscall_index = sc_glue_t->kail_syscall_index;
            trampoline_glue_t->syscall_index32 = sc_glue_t->syscall_index32;
            ;




            keepLooping = 1;
            while (keepLooping > 0) {
               curGlueTypeMsg = "";
               switch (keepLooping) {

               case 1:
                      curGlueFunction = sc_glue_t->syscall_glue_pre;
                      curTrampolineGlueFnEntry = &trampoline_glue_t->syscall_glue_pre;
                      curGlueTypeMsg = "pre";
                      break;
               case 2:
                      curGlueFunction = sc_glue_t->syscall_glue_post;
                      curTrampolineGlueFnEntry = &trampoline_glue_t->syscall_glue_post;
                      curGlueTypeMsg = "post";
                      break;
               case 3:
                      curGlueFunction = sc_glue_t->syscall_glue_pre_post;
                      curTrampolineGlueFnEntry = &trampoline_glue_t->syscall_glue_pre_post;
                      curGlueTypeMsg = "pre_post";
                      break;

               case 4:
                      curGlueFunction = sc_glue_t->sys32call_glue_pre;
                      curTrampolineGlueFnEntry = &trampoline_glue_t->sys32call_glue_pre;
                      curGlueTypeMsg = "32pre";
                      break;
               case 5:
                      curGlueFunction = sc_glue_t->sys32call_glue_post;
                      curTrampolineGlueFnEntry = &trampoline_glue_t->sys32call_glue_post;
                      curGlueTypeMsg = "32post";
                      break;
               case 6:
                      curGlueFunction = sc_glue_t->sys32call_glue_pre_post;
                      curTrampolineGlueFnEntry = &trampoline_glue_t->sys32call_glue_pre_post;
                      curGlueTypeMsg = "32pre_post";
                      break;

               default:
                      curGlueFunction = (sys_call_fn)0;
                      keepLooping = 0;
                      curGlueTypeMsg = "NONE";
               }
               if (keepLooping == 0) {
                  break;
               }

               ;




               if (! curGlueFunction) {

                   ++keepLooping;
                    continue;
               }


               ;

               if (! curTrampolineFnPtr) {
                    printk(" ERROR: kail_syscall.c setup trampoline index: %ld kmalloc new function ptr NULL \n",
                            (unsigned long)index);
                   return 2;
               }
               if ((__u64)curTrampolineFnPtr > 0x7ffffffff) {
                    printk(" ERROR: kail_syscall.c setup trampoline index: %ld kmalloc function ptr is too FAR: %lX \n",
                            (unsigned long)index, (unsigned long)curTrampolineFnPtr);

                   return 2;
               }



               memset(curTrampolineFnPtr, 0, trampolineBfrEntrySize);

               memcpy(curTrampolineFnPtr, (char *)trampoline, trampolineSize);


               curBranchAddr = (unsigned long *)((char *)curTrampolineFnPtr + trampolineLOCindex);
               *curBranchAddr = (unsigned long)curGlueFunction;



               tmpShrtPtr = (unsigned short *)curTrampolineFnPtr;
               ;






               *curTrampolineGlueFnEntry = (sys_call_fn)curTrampolineFnPtr;

               ++keepLooping;
               curTrampolineFnPtr += trampolineBfrEntrySize;
               memset(curTrampolineFnPtr, 0, 4);
            }

   }







      ;





      kail_syscall_glue_list = trampoline_glue_list;






          return 0;





}
asmlinkage int kail_setup_for_trampoline(struct syscall_glue_table *sc_glue_t,
                                         unsigned int *glueFnCount, int verboseLevel) {
   int curIndex = 0;
   int fnCount = 0;
   if (sc_glue_t == NULL)
        sc_glue_t = &kail_syscall_glue_list_x[0];





   for (curIndex = 0;
          curIndex < 100;
                sc_glue_t++, curIndex++) {
     if (glueFnCount) {
        if (sc_glue_t->syscall_glue_pre)
           ++fnCount;
        if (sc_glue_t->syscall_glue_post)
           ++fnCount;
        if (sc_glue_t->syscall_glue_pre_post)
           ++fnCount;
        if (sc_glue_t->sys32call_glue_pre)
           ++fnCount;
        if (sc_glue_t->sys32call_glue_post)
           ++fnCount;
        if (sc_glue_t->sys32call_glue_pre_post)
           ++fnCount;
      }
     if (sc_glue_t->syscall_index == -1
            && sc_glue_t->kail_syscall_index == -1) {
         break;
     }
    if (sc_glue_t->kail_syscall_index == -2) continue;


      if ((sc_glue_t->kail_syscall_index > 255) || (sc_glue_t->kail_syscall_index < 0) ){

          printk(" ERROR: kail_syscall.c setup for trampoline.. INVALID %d index:(%d)\n",
                curIndex, sc_glue_t->kail_syscall_index);
          return 0;
      }
   }
   if (glueFnCount)
      *glueFnCount = fnCount;
   return curIndex;
}
